<?php

/* -------------------------------------------

Component: com_DBBackups
Author: Barnaby Dixon
Email: barnaby@php-web-design.com
Copywrite: Copywrite (C) 2010 Barnaby Dixon. All Rights Reserved.
License: http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL

---------------------------------------------*/

//No Direct Access

defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class DbBackupsController extends JController {

	function __construct( $default = array()) {
		parent::__construct( $default );
		$this->registerTask( 'generatebackup', 'generatebackup');
		$this->registerTask( 'deletebackup', 'deletebackup');
		$this->registerTask( 'restorebackup', 'restorebackup');
	}

	function display( )
	{
		JRequest::setVar('view', 'default');
		JRequest::setVar( 'hidemainmenu', 0 );
		parent::display();
	}

	function backup() { }

	function generatebackup() {

		// Pre-Load configuration
		require_once( JPATH_CONFIGURATION	.DS.'configuration.php' );

		//SYSTEM CONFIGURATION
		$CONFIG = new JConfig();
		$db	=& JFactory::getDBO();

		//SET VARIABLES
		$name = $CONFIG->db;

		$dbh = escapeshellarg("-h".$CONFIG->host);
		$dbu = escapeshellarg("-u".$CONFIG->user);
		$dbp = escapeshellarg("-p".$CONFIG->password);
		$dbn = escapeshellarg($name);

		$backupFile = $name . '_'. time() . '.sql.gz';
		$linkFile = "components/com_dbbackups/dbBackUps/".$backupFile;
		$targetFile = escapeshellarg($linkFile);

		//GET REPAIR & OPTIMIZE SETTINGS
		$o = "--silent";
		$query = "SELECT optimize, repair FROM #__dbbackups_config WHERE id='1' LIMIT 1";
		$db->setQuery($query);
		$opts = $db->loadAssoc();
		if($opts['optimize'] == '1') $o .= " -o ";
		if($opts['repair'] == '1') $o .= " -r ";

		//CHECK DATABASE & OPTIMIZE
		$command = "mysqlcheck $o $dbh $dbu $dbp $dbn";
		system($command, $ret);

		//GET DB TABLES
		$query = "SHOW TABLES FROM $name";
		$db->setQuery($query);
		$ab = $db->loadResultArray();
		foreach($ab as $a => $b) {
			if(strpos($b, '_session') || strpos($b, '_dbbackups')) continue;
			else $tables .= " ".$b;
		}

		//BACKUP DATABASE
		$command = "mysqldump --opt $dbh $dbu $dbp $dbn $tables | gzip -9 > $targetFile";
		system($command, $ret);

		//ADD RECORD TO DATABASE
		if($ret == '0') {
			$msg = "Backup generated - <a href='$linkFile'>Click here to download the data file</a>";

			$query = "INSERT INTO `#__dbbackups` SET `backup` = '".$backupFile."', `date` = '".date('Y-m-j H:i:s')."'";
			$db->setQuery($query);
			$db->query();
		}
		else {
			$msg = "Unable to create restore point - please check your system";
		}
		$this->setRedirect( 'index.php?option=com_dbbackups', $msg );
	}

	function deletebackup() {

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$db	=& JFactory::getDBO();
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );

		JArrayHelper::toInteger($cid);
		$msg = '';
		$s = "";
		$n=count($cid);
		if($n < 1) {
			$msg = "Please select a backup to remove";
		} else {
			if($n>1) $s = "s";
			for ($i=0; $i<$n; $i++)
			{
				$csr =& JTable::getInstance('dbbackups', 'Table');
				$query = "SELECT backup FROM `#__dbbackups` WHERE `id` = 	'".$cid[$i]."'";
				$db->setQuery($query);
				$results = $db->loadAssocList();

				$backup = $results[0]['backup'];
				$target = "components/com_dbbackups/dbBackUps/{$backup}";
				if(file_exists($target)) unlink($target);

				if (!$csr->delete_db( $cid[$i] )) {
					$msg .= $csr->getError();
				} else {
					$msg = "Backup{$s} deleted";
				}
			}
		}
		$this->setRedirect( 'index.php?option=com_dbbackups', $msg );
	}

	function restorebackup() {

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$db		=& JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(), '', 'array' );

		JArrayHelper::toInteger($cid);
		$msg = '';
		if(count($cid)>1) {
			$msg = "Please only select one restore point";
		} else {
			$query = "SELECT backup FROM `#__dbbackups` WHERE `id` = '".$cid[0]."'";
			$db->setQuery($query);
			$results = $db->loadAssocList();
			$backup = $results[0]['backup'];

			// Pre-Load configuration
			require_once( JPATH_CONFIGURATION	.DS.'configuration.php' );

			// System configuration
			$CONFIG = new JConfig();
			$dbn = escapeshellarg($CONFIG->db);
			$dbu = escapeshellarg("-u".$CONFIG->user);
			$dbp = escapeshellarg("-p".$CONFIG->password);
			$dbh = escapeshellarg("-h".$CONFIG->host);
			$backupFile = escapeshellarg('components/com_dbbackups/dbBackUps/'.$backup);
			$command = "gunzip < $backupFile | mysql $dbh $dbu $dbp $dbn";
			system($command, $ret);
			if($ret == '0') $msg = "Database Restored";
			else $msg = "Unable to restore database - please check your system";
		}
		$this->setRedirect( 'index.php?option=com_dbbackups', $msg );
	}
}